﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private LineChart1 As xChartLite
	Private B4XTable1 As B4XTable
	Private NumberColumn As B4XTableColumn
	Public BLEman As BleManager2
	#if B4A or B4i
	Private btnPrev As Button
	Private btnNext As Button
	#end if
'End Sub

'Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
'	Public rp As RuntimePermissions
	Private lblState As Label
	Private btnReadData As Button
	Private btnDisconnect As Button
	Private btnScan As Button
	Private lblDeviceStatus As Label
	Private pbReadData As ProgressBar
	Private pbScan As ProgressBar
	Private clv As CustomListView
	Private scanTime As Int = 30000
	Private devices As List
	Public myCharacteristics As List
	Private ServiceId As String
	Private	Notifed As Boolean=False
	Private Label1 As Label
	Private Label2 As Label
	Private CheckBoxT1 As CheckBox
	Private EnabNotify As Button
	Public myServiceId As String = "0000babe-0000-1000-8000-00805f9b34fb"
	Public myRdCharId As String = "f000bead-0451-4000-b000-000000000000"
	Private NotifyBit As Label
End Sub

Sub Process_Globals

End Sub

Sub Globals

End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Button9_Click
	'Root.LoadLayout("MainPage")
	'B4XPages.SetTitle(Me, "           ESSI - FW6 Test/Configure/Control Device. V1.00")
#If B4i
	Sleep(1000)		'needed in B4i, I do not know why.
#End If
End Sub

Private Sub CreateLineChart1Data
	' clear previous data
	LineChart1.ClearData
	
	' initialize the line data
	LineChart1.AddLine("Random", xui.Color_Blue) '0 = random color
	LineChart1.AddLine("Cos", xui.Color_Red)
	LineChart1.AddLine("Sin", xui.Color_Magenta)
	
	' generate random amplitudes
	Dim Ampl1, Ampl2, Ampl3 As Double
	Ampl1 = Rnd(1, 10001) / 50
	Ampl2 = Rnd(1, 10001) / 50
	Ampl3 = Rnd(1, 10001) / 502
	' add the line points.
	For i = 0 To 490
		' In the case of 2 lines or more we are adding an array of values.
		' One for each line.
		' Make sure to create an array for each point.
		' You cannot reuse a single array for all points.
		LineChart1.AddLineMultiplePoints(i, Array As Double(Rnd(-200, 201) / 300 * Ampl1 + 5, Ampl2 * CosD(3 * i) + 2, Ampl3 * SinD(i) + 4), i Mod 90 = 0)
	Next
	
	' Put up chart with new data...
	LineChart1.DrawChart
End Sub

Private Sub btnLineCharts_Click
	CreateLineChart1Data
	LineChart1.Visible = True
End Sub

Private Sub Button1_Click
	Root.RemoveAllViews
	Root.LoadLayout("ScanPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:      Scan / Connect to device. ")
End Sub

Private Sub Button2_Click
	Root.RemoveAllViews
	Root.LoadLayout("ConfigPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:     Configure connected device. ")
End Sub

Private Sub Button3_Click
	Root.RemoveAllViews
	Root.LoadLayout("RunPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:      Direct Test Control of Device. ")
End Sub

Private Sub Button4_Click
	Root.RemoveAllViews
	Root.LoadLayout("GraphPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:          Show Graphs of V/I. ")
	' put up a demo graph for now
	btnLineCharts_Click
End Sub

Private Sub CreateCustomFormat (c As B4XTableColumn)
	Dim formatter As B4XFormatter
	formatter.Initialize
	c.Formatter = formatter
	Dim Positive As B4XFormatData = c.Formatter.NewFormatData
	Positive.TextColor = B4XTable1.TextColor
	Positive.FormatFont = xui.CreateDefaultFont(16)
	c.Formatter.AddFormatData(Positive, 0, c.Formatter.MAX_VALUE, True) 'Inclusive (zero included)
	Dim Negative As B4XFormatData = c.Formatter.CopyFormatData(Positive)
	Negative.TextColor = xui.Color_Red
	Negative.FormatFont = xui.CreateDefaultBoldFont(16)
	Negative.Prefix = "("
	Negative.Postfix = ")"
	c.Formatter.AddFormatData(Negative,c.Formatter.MIN_VALUE, 0, False)
End Sub

Private Sub Button5_Click
	Root.RemoveAllViews
	Root.LoadLayout("LogsPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:      Show Device Logs. ")
	'create the columns
	B4XTable1.AddColumn("US County", B4XTable1.COLUMN_TYPE_NUMBERS)
	B4XTable1.AddColumn("Name", B4XTable1.COLUMN_TYPE_TEXT)
	Dim StateColumn As B4XTableColumn = B4XTable1.AddColumn("State", B4XTable1.COLUMN_TYPE_TEXT)
	StateColumn.Width = 80dip
	NumberColumn = B4XTable1.AddColumn("Number", B4XTable1.COLUMN_TYPE_NUMBERS)
	CreateCustomFormat(NumberColumn)
	Dim parser As CSVParser
	parser.Initialize
	Dim data As List = parser.Parse(File.ReadString(File.DirAssets, "us_counties.csv"), ",", True)
	B4XTable1.SetData(data)
	'change the visible colums order
	'remove the number columns
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(NumberColumn))
	B4XTable1.VisibleColumns.InsertAt(1, NumberColumn)
	B4XTable1.Refresh
End Sub

Sub btnNext_Click
	B4XTable1.CurrentPage = B4XTable1.CurrentPage + 1
End Sub

Sub btnPrev_Click
	B4XTable1.CurrentPage = B4XTable1.CurrentPage - 1
End Sub

Sub B4XTable1_DataUpdated
	#if B4A or B4i
	btnNext.Visible = B4XTable1.lblNext.Tag
	btnPrev.Visible = B4XTable1.lblBack.Tag
	#end if
End Sub

Sub B4XSwitch1_ValueChanged (Value As Boolean)
	If Value Then
		'create custom filter
		B4XTable1.CreateDataView($"${NumberColumn.SQLID} > 10"$)
	Else
		B4XTable1.ClearDataView
	End If
End Sub

Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)
'	Dim RowData As Map = B4XTable1.GetRow(RowId)
'	Dim cell As String = RowData.Get(ColumnId)
'	B4XPages.SetTitle(Me, cell)
End Sub

Private Sub Button6_Click
	Root.RemoveAllViews
	Root.LoadLayout("ScanPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6:      Scan and connect to device. ")

End Sub

Private Sub Button9_Click
	Root.RemoveAllViews
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "           ESSI - FW6 Test/Configure/Control Device. V1.00")
End Sub

'
'=================================================================================
'
Sub Service_Create
	BLEman.Initialize("BLEman")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub
'
' ====================== BLE stuff =========================
'
Sub Activity_Create(FirstTime As Boolean)
	' 	Activity.LoadLayout("1")
'	If FirstTime = True Then
'		Timer1.Initialize("Timer1", 2000 )'
'		TimerON = False
'		Timer1.Enabled=True
'	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_Resume
	StateChanged
End Sub

Public Sub StateChanged
	lblState.Text = currentStateText
	If connected Then
		lblDeviceStatus.Text = "Connected: " & ConnectedName
	Else
		lblDeviceStatus.Text = "Not Connected"
	End If
	btnDisconnect.Enabled = connected
	btnScan.Enabled = Not(connected)
	pbReadData.Visible = False
	pbScan.Visible = False
	btnReadData.Enabled = connected
	btnScan.Enabled = (currentState = BLEman.STATE_POWERED_ON) And connected = False
End Sub

Sub btnScan_Click
	If btnScan.Text = "Start Scan" Then
'		rp.CheckAndRequest(rp.PERMISSION_ACCESS_COARSE_LOCATION)
'		Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
'		If Result = False Then Return
		pbScan.Visible = True
		btnScan.Text = "Stop Scan"
		clv.Clear
		devices.Initialize
		StartScan
		Sleep(scanTime)
	End If
	StopScan
	btnScan.Text = "Start Scan"
	pbScan.Visible = False
End Sub

Sub DoDataAvailable (Service As String, characteristics As Map)
	pbReadData.Visible = False
	clv.Add(CreateServiceItem(Service), "")
	For Each id As String In characteristics.Keys
		clv.Add(CreateCharacteristicItem(id, characteristics.Get(id)), "")
	Next

	' BEGIN: added to dump out all fields for characteristic
	Log("Svc: " & Service)
	For i = 0 To characteristics.Size - 1
		Log("Key: " & characteristics.GetKeyAt(i))
'		Log("Val: " & characteristics.GetValueAt(i))
		Dim BC As ByteConverter
		Dim davalue As String = BC.StringFromBytes(characteristics.GetValueAt(i),"utf-8")
		Log("Str: " & davalue )
		'  END: added to dump out all fields for characteristic
		' process the notify and light an indicator
		If Service = myServiceId Then
			If  characteristics.GetKeyAt(i) = myRdCharId Then
				If davalue.Length>1 Then
					If davalue.CharAt(0) = "1" Then
						NotifyBit.text = "   ON"
						NotifyBit.Color= Colors.RGB(255,255,0)
					Else
						NotifyBit.text = "  OFF"
						NotifyBit.Color= Colors.RGB(200,200,200)
					End If
				End If
			End If
		End If
	Next
	Log(" ")
	decodeChar( ServiceId, characteristics ) ' my add from forum
End Sub

Sub DeviceAvailable (name As String, id As String)
	Dim myDevice As Device
	myDevice.Name = name
	myDevice.Id = id
	devices.Add(myDevice)
	clv.Add(CreateDeviceItem(name, id), "")
End Sub

Sub btnDisconnect_Click
	Disconnect
	clv.Clear
End Sub

Sub btnReadData_Click
	pbReadData.Visible = True
	clv.Clear
	myCharacteristics.Initialize
	ReadData
End Sub

Sub CreateDeviceItem (name As String, id As String) As Panel
	Dim pnl As Panel
	pnl.Initialize("")
	pnl.Color = 0xFF808080
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 30dip)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = name & " (" & id & ")"
	lbl.Gravity = Gravity.CENTER
	lbl.Typeface = Typeface.DEFAULT_BOLD
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 30dip)
	Return pnl
End Sub

Sub CreateServiceItem (Service As String) As Panel
	ServiceId = Service
	Dim characteristic As Characteristic
	characteristic.ServiceId = ServiceId
	characteristic.CharacteristicId = ""
	characteristic.Value = ""
	myCharacteristics.Add(characteristic)
	Dim pnl As Panel
	pnl.Initialize("")
	pnl.Color = 0xFF808080
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 30dip)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = Service
	lbl.Gravity = Gravity.CENTER
	lbl.Typeface = Typeface.DEFAULT_BOLD
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 30dip)
	Return pnl
End Sub

Sub CreateCharacteristicItem(Id As String, Data() As Byte) As Panel
	Dim characteristic As Characteristic
	characteristic.ServiceId = ServiceId
	characteristic.CharacteristicId = Id
	characteristic.Value = ""
	myCharacteristics.Add(characteristic)
	Dim pnl As Panel
	pnl.Initialize("")
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 40dip)
	pnl.Color = Colors.White
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = Id
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 20dip)
	Dim lbl2 As Label
	lbl2.Initialize("")
	Try
		lbl2.Text = BytesToString(Data, 0, Data.Length, "UTF8")
	Catch
		Log(LastException)
		lbl2.Text = "Error reading data as string"
	End Try
	lbl2.TextColor = 0xFF909090
	lbl2.TextSize = 14
	pnl.AddView(lbl2, 0, 20dip, clv.AsView.Width, 20dip)
	Return pnl
End Sub

Sub clv_ItemClick (Index As Int, Value As Object)
	If lblDeviceStatus.Text = "Not Connected" Then
		Dim myDevice As Device = devices.Get(Index)
		Log("Device Selected: " & myDevice.Name & " (" & myDevice.Id & ")")
		ConnectDevice( myDevice.Name, myDevice.Id)
		StopScan
		btnScan.Text = "Start Scan"
		pbScan.Visible = False
	Else
		Dim id As InputDialog
		Dim sf As Object = id.ShowAsync("", "Text to Send", "Ok", "", "Cancel", Null, False)
		Wait For (sf) Dialog_Result(Result As Int)
		If Result = DialogResponse.POSITIVE Then
			Dim myCharacteristic As Characteristic = myCharacteristics.Get(Index)
			WriteData( myCharacteristic, id.Input)
		End If
	End If
End Sub

Private Sub EnabNotify_Click
	Dim VarPar As Map
	VarPar.Initialize
	VarPar.Put("SvId", myServiceId)
	VarPar.Put("CrId", myRdCharId)
	If Notifed Then
		Notifed = False
		VarPar.Put("Flag", False )
		enableNotify( VarPar )
		EnabNotify.Text="NotifyOFF"
	Else
		Notifed = True
		VarPar.Put("Flag", True )
		enableNotify( VarPar )
		EnabNotify.Text= "NotifyON"
	End If
End Sub
'
'======================================================
'
'
' ============= start BLE2 direct subs
'
Sub BLEman_DataAvailable ( xServiceId As String, xCharacteristics As Map )
	DoDataAvailable( xServiceId, xCharacteristics )
End Sub

Sub BLEman_Disconnected
	Log("Disconnected")
	connected = False 
	StateChanged
End Sub

Sub BLEman_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	StateChanged
End Sub

Sub BLEman_StateChanged (State As Int)
	Select State
		Case BLEman.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case BLEman.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case BLEman.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	StateChanged
End Sub

Sub BLEman_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	DeviceAvailable( Name, Id)
End Sub
'
' ============= end BLE2 direct subs
'
Public Sub ReadData
	For Each s As String In ConnectedServices
		BLEman.ReadData(s)
	Next
End Sub

Public Sub Disconnect
	BLEman.Disconnect
	BLEman_Disconnected
End Sub

Sub ConnectDevice(Name As String, Id As String)
	ConnectedName = Name
	BLEman.StopScan
	BLEman.Connect2(Id, True) 'disabling auto connect can make the connection quicker
End Sub

Public Sub StartScan
	If BLEman.State <> BLEman.STATE_POWERED_ON Then
		Log("Not powered on.")
'	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
'		Log("No location permission.")
	Else
		BLEman.Scan2(Null, False)
	End If
End Sub

Public Sub StopScan
	BLEman.StopScan
End Sub

' my add from forum to display characteristic properties
Sub doProps( Properties As Int ) As String
	Dim props As Map = CreateMap( _
	 1: "B," , _ 
	 2: "R," , _
	 4: "WO,", _
	 8: "WR,", _
	16: "N," )
	Dim sb As StringBuilder
	sb.Initialize
	For Each key As Int In props.Keys
		If Bit.And(Properties, key) <> 0 Then sb.Append( props.Get(key) )
	Next
	Return sb
End Sub

Sub PrintCharProperties(Characteristic As String, Properties As Int)
	Log($"${Characteristic} Properties: ${doProps(Properties)}"$)
End Sub

Public Sub decodeChar(Serv As String, Charact As Map)
	For Each c As String In Charact.Keys
		PrintCharProperties(c, BLEman.GetCharacteristicProperties(Serv, c))
	Next
End Sub
' end my

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

' Sub TestNumber(s As String) As Boolean
'	Return IsNumber(s) And Regex.IsMatch("[\d\.]+", s)
' End Sub

public Sub WriteData(Characteristic As Object, Value As String)
	If Not(connected) Then Return
	Dim myCharacteristic As Characteristic = Characteristic
	Log("Write: " & Value & " to " & myCharacteristic.CharacteristicId )
	BLEman.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, Value.GetBytes("UTF8"))
End Sub

Public Sub enableNotify( VarPar As Map )
	Dim srvId As String = VarPar.Get("SvId")
	Dim chrId As String = VarPar.Get("CrId")
	Dim flag As Boolean = VarPar.get("Flag")
	Dim r As Boolean = BLEman.SetNotify(srvId,chrId,flag)
	If( r ) Then
		Log("enabNotifySet: " & flag )
	Else
		Log("enabNotifyFail: " & flag )
	End If
End Sub